#!/usr/bin/env python3
from unidecode import unidecode
from math import *
import string
import matplotlib.pyplot as plt


##############################################################################
#                                 PRELIMINAIRES
##############################################################################
   
##############################################################################
#0-LES FICHIERS EN CLAIR
##############################################################################

alphabet = list(string.ascii_lowercase)

#returns the list of all lists of length 2: [key,dico[key]]
def dico_to_listlist(D:dict):
    LL=[]
    for k in D.keys():
        LL.append([k,D[k]])
    return LL

##############################################################################
#                        1-CODAGE MONOALPHABETIQUE
##############################################################################

#w is a permutation of the alphabet
#returns a dictionary representing this permutation
def string_to_dico(w:str):
    dico={}
    for i in range(len(w)):
        dico[alphabet[i]]=w[i]
    return dico
    

#cree un fichier dest.txt; lui affecte l'encryptage de source.txt avec la cle keydico
def cipher_mono(source:str,dest:str,keydico:dict):
    f = open(source+".txt", "r")
    g = open(dest+".txt", "w")
    #treat each line x of f
    for x in f:
        txt = ""
        for i in x:
            #encrypts character i, " " by default
            #case where i has a defined encryption
            pass
            #defaut case: i is erased
        #chaque ligne encryptee se termine par un saut de ligne
        g.write(txt + "\n")
    g.close()
    f.close()


#dico is assumed injective
#returns the inverse relation
def inverse_dico(dico:dict):
    inv={}
    for k in dico.keys():
        inv[dico[k]]=k
    return inv

#print(inverse_dico(key_mono))

def decipher_mono(source:str,dest:str,keydico:dict):
     cipher_mono(source,dest,inverse_dico(keydico))
          
#freq is the list of all [letter,frequency] in french
#it is a list of lists

freq = []
freq.append(["e",12.1])
freq.append(["a",7.11])
freq.append(["i",6.59])
freq.append(["s",6.51])
freq.append(["n",6.39])
freq.append(["r",6.07])
freq.append(["t",5.92])
freq.append(["o",5.02])
freq.append(["l",4.96])
freq.append(["u",4.49])
freq.append(["d",3.67])
freq.append(["c",3.18])
freq.append(["m",2.62])
freq.append(["p",2.49])
freq.append(["g",1.23])
freq.append(["b",1.14])
freq.append(["v",1.11])
freq.append(["h",1.11])
freq.append(["f",1.11])
freq.append(["q",0.65])
freq.append(["y",0.46])
freq.append(["x",0.38])
freq.append(["j",0.34])
freq.append(["k",0.29])
freq.append(["w",0.17])
freq.append(["z",0.15])


#essaye de decrypter le fichier cipher.txt
#affecte une cle partielle ;imprime le cryptage avec cette cle.
#c'est donc le decryptage avec la cle inverse
def decrypt_on_the_fly(cipher:str):
    f = open(cipher+".txt", "r")
    txt = ""
    for x in f:
        txt = txt + x.replace("\n","")    
    explore_dico = {}
    explore_dico[" "] = " "
    explore_dico["v"] = "e"
    # add more letters here and explore
    decrypt = ""
    for c in (txt):
        if c in explore_dico.keys():
            decrypt = decrypt + explore_dico[c]
        else:
            decrypt = decrypt + "-"
    print(decrypt)
    f.close()
    
#affecte une cle partielle (inverse);
#imprime le decryptage avec cette cle (en minuscule)
#imprime les lettres cryptees (en majuscule)
def superp_on_the_fly(cipher:str):
    f = open(cipher+".txt", "r")
    pass
    f.close()
    
#describes the frequencies of letters, in the cryptogram,versus,  in french
#helps to guess the alphabet encription
def mono_break_study(cipher:str):
    pass
    


###############################################################################
#                                2- CODAGE de VIGENERE
###############################################################################
#2.1 ENCODAGE-DECODAGE
###############################################################################
letter_number = {}
number_letter = {}

for n,i in  enumerate(alphabet):
    #translation from letter to number
    letter_number[i] = n
    #translation from number to letter
    number_letter[n] = i
    

#returns the list of the ranks of the letters of the word w
def alpha_to_num(w:str):
    num=[]
    for i in w:
        num.append(letter_number[i])
    return num

#returns the list of the characters whose ranks constitute the list L
def num_to_alpha(L:list):
    return None

#returns the word of characters whose ranks constitute the list L
def num_to_word(L:list):
    return None

# enkrypts source.txt into dest.txt using key, Vigenere protocol
def cipher_poly(source:str,dest:str,key:list):
    pass
    
    #source.txt and dest.txt have same  shape (i.e. sequence of letters,spaces,newlines)

#returns the inverse of key
def inverse(key:list):
    inv=[]
    for i in key:
        inv.append((-i) % 26)
    return inv

#affecte au fichier dest.txt le decryptage de source.txt, pour la cle key
def decipher_poly(source:str,dest:str,key:list):
    pass
    

###############################################################################
#2.2 CRYPTANALYSE
###############################################################################

#returns the list of alphabetic characters of the file nomfic
def file_to_list(nomfic:str):
    res=[]
    return res

#criter is a boolean function over integers;
#returns the sublist made of the positions satisfying crit
def sublist(L:list,criter):
    subl=[]
    return subl

#mapcar for a dictionary: returns the composition of D by f (on the left)
def mapcardic(D:dict,f):
    res={}
    for index in D.keys():
        res[index]= f(D[index])
    return res


#returns the dictionary of empirical probabilities of characters,
#in the list L
def list_to_proba(L:list):
     return None


#returns the sum of all elements of a dictionnary   
def sumdic(D:dict):
    sum=0
    return sum


def xlogx(x:float):
    if x != 0:
        return(- x * log2(x))
    else:
        return 0

#returns the entropy of a probability measure;.
#the measure is given as a dictionary
def entropy(D:dict):
    return 1


#returns the uniform distribution over [0,n-1]
def uniform(n:int):
    proba={}
    for i in range(n):
        proba[i]=1/n
    return proba


#returns the entropy of the sublist defined by the function criter over the indices
def subentropy(L:list,criter):
    return 1

#L is a ist of letters in alphabet
#returns the subentropies of L for all criteria: i % modulo ==j
#result is a list A of length modulo; A[j] = entropy for i % modulo ==j
#entropy is nrmalized between 0 and 1
def all_entrop(L:list,modulo:int):
    all=[0]*modulo
    return all


#returns all the min-entropies of sublists for all moduli <= M (and >=1)
#the entropies are normalised into [0,1]
def all_min(L:list,M:int):
    l=len(L)
    minS=[0]*(M+1)
    return minS

   
##Computing the key of length kl

#returns the listlist of [letter,proba] for each residue in [0,kl-1]
#it is a listlistlist
def freq_mod(L:str,kl:int):
    freqmod=[0]*kl
    return freqmod

#returns candidate-key: a list of kl numbers in [0,25]
#LLL: the sequence (for r in [0,kl-1]), of lists of lists [letter,proba]
def guess_key(LLL:list,kl:int):
    key=[0]*kl
    return key



#calcule la cle secrete de Vigenere a partir du cryptogramme cipher (dans le fichier de nom cipher)
#on suppose que la cle a une lngueur <= 20
def break_cipher_poly(cipher:str):
    #calcul du modulo qui minimise l'entropie(normalisee entre 0 et 1)
    #length of the key is the modulus that minimizes entropy
    KEY=[]
    KEY_poly_guess=""
    print("numerical key", KEY)
    print("alphabetical key", KEY_poly_guess)

   
###############################################################################
#                                   3-LOI de ZIPF
###############################################################################
#affecte a nb_words la liste des couples (rang(mot),nb-occur(mot)), par ordre decroissant
#loi de zipf: les log de ces couples sont sur une droite
def zipf_law():
    f = open("clear.txt", "r")
    txt = ""
    #txt est une version de f en un seul string
    #construire un fichier zipf.png qui contient la courbe
    f.close()
    
###############################################################################
#                           execution des 3 parties
###############################################################################
        
def main():
    mono_break_study("cipher")
    superp_on_the_fly("cipher")
    break_cipher_poly("cipher_poly")
    zipf_law()
    
main()


